// MonPageFaultDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MonPageFault.h"
#include "MonPageFaultDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonPageFaultDlg dialog

CMonPageFaultDlg::CMonPageFaultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMonPageFaultDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMonPageFaultDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMonPageFaultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonPageFaultDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMonPageFaultDlg, CDialog)
	//{{AFX_MSG_MAP(CMonPageFaultDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_START, OnStart)
	ON_BN_CLICKED(BTN_END, OnEnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonPageFaultDlg message handlers

BOOL CMonPageFaultDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMonPageFaultDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMonPageFaultDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMonPageFaultDlg::OnOK() 
{
	// TODO: Add extra validation		
	
	CDialog::OnOK();
}
		
void CMonPageFaultDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

#include "DrvFunc.h"
#include "..\sys\prism.h"

#define DRIVE_NAME	"PageFault"

HANDLE G_hDrv = NULL;
void CMonPageFaultDlg::OnStart() 
{

	DWORD  dwDummy;

	if(G_hDrv) return;

	G_hDrv = MakeDrvSimpleStart(NULL, DRIVE_NAME);	
	if(G_hDrv == NULL) 
	{
		AfxMessageBox("Error");
		return;
	}
	
	AfxMessageBox("Ready");

	MakeDrvIoControl (G_hDrv, IOCTL_START_MON, &dwDummy, sizeof(DWORD), &dwDummy, sizeof(DWORD));
		
}

void CMonPageFaultDlg::OnEnd() 
{
	DWORD  dwDummy;
	
	if(G_hDrv)
	{
		MakeDrvIoControl (G_hDrv, IOCTL_END_MON, &dwDummy, sizeof(DWORD), &dwDummy, sizeof(DWORD));
		MakeDrvStop(DRIVE_NAME, G_hDrv);
	}

}

BOOL CMonPageFaultDlg::DestroyWindow() 
{
	OnEnd();
	return CDialog::DestroyWindow();
}
